Type: Package
Package: OwenQ
Title: Owen Q-Function
Version: 1.0.7
Author: Stéphane Laurent
Maintainer: Stéphane Laurent <laurent_step@outlook.fr>
Description: Evaluates the Owen Q-function for an integer value of the
    degrees of freedom, by applying Owen's algorithm (1965)
    <doi:10.1093/biomet/52.3-4.437>.  It is useful for the calculation of
    the power of equivalence tests.
License: BSD_3_clause + file LICENSE
URL: https://github.com/stla/OwenQ
BugReports: https://github.com/stla/OwenQ/issues
Imports: Rcpp (>= 0.12.10), stats
Suggests: knitr, mvtnorm, rmarkdown, testthat
LinkingTo: BH, Rcpp, RcppEigen, RcppNumerical
VignetteBuilder: knitr
Encoding: UTF-8
RoxygenNote: 7.0.2
SystemRequirements: C++17
NeedsCompilation: yes
Packaged: 2023-04-11 11:50:51 UTC; stla
Repository: CRAN
Date/Publication: 2023-04-11 12:20:02 UTC
Built: R 4.4.0; x86_64-apple-darwin19.6.0; 2024-05-05 20:27:41 UTC; unix

context("spowen2")

test_that("Tolerance factors", {
  p <- 0.9
  n <- 10
  delta <- sqrt(n)*qnorm((1+p)/2)
  ke <- 3.197
  t <- ke*sqrt(n)
  expect_equal(spowen2(n-1, t, delta), 0.95, tolerance=1e-3)
  ke <- 2.84
  t <- ke*sqrt(n)
  expect_equal(spowen2(n-1, t, delta), 0.9, tolerance=1e-3)
  ke <- 4.066
  t <- ke*sqrt(n)
  expect_equal(spowen2(n-1, t, delta), 0.99, tolerance=1e-3)
})

context("powen algo2")

algo <- 2

test_that("powen4", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- OwenQ1(nu, t2, delta2, R, algo) - OwenQ1(nu, t1, delta1, R, algo)
  owen4 <- powen4(nu, t1, t2, delta1, delta2, algo)
  expect_equal(diff, owen4, tolerance=1e-16)
  wolfram <- 0.01785518085912236
  expect_equal(owen4, wolfram, tolerance=1e-11)
  #
  nu <- 5
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- OwenQ1(nu, t2, delta2, R, algo) - OwenQ1(nu, t1, delta1, R, algo)
  owen4 <- powen4(nu, t1, t2, delta1, delta2, algo)
  expect_equal(diff, owen4, tolerance=1e-16)
  wolfram <- 0.01868982415809893
  expect_equal(owen4, wolfram, tolerance=1e-9)
})

test_that("Comparison with PASS", {
  skip_if(.Machine$sizeof.pointer < 8L) # skip if 32 bits
  powerTOST <- function(alpha, delta0, Delta, sigma, n1, n2){
    se <- sqrt(1/n1 + 1/n2)*sigma
    delta1 <- (delta0+Delta)/se
    delta2 <- (delta0-Delta)/se
    dof <- n1+n2-2
    q <- qt(1-alpha, dof)
    powen4(dof, q, -q, delta1, delta2, algo)
  }
  PASS <- structure(list(power = c(0.3909, 0.6954, 0.8558, 0.9343, 0.9709,
                                   0.3827, 0.6784, 0.8366, 0.9178, 0.9589, 0.3591, 0.6295, 0.7807,
                                   0.868, 0.9202, 0.3229, 0.5554, 0.6932, 0.7847, 0.8491, 0.2782,
                                   0.4653, 0.5831, 0.6717, 0.7426, 0.2297, 0.3697, 0.4621, 0.5388,
                                   0.606, 0.7037, 0.8576, 0.9232, 0.9545, 0.9709, 0.6865, 0.8385,
                                   0.906, 0.94, 0.9589, 0.637, 0.7826, 0.8544, 0.895, 0.9202, 0.5619,
                                   0.695, 0.7694, 0.8168, 0.8491, 0.4706, 0.5847, 0.6561, 0.7059,
                                   0.7426, 0.3736, 0.4634, 0.5247, 0.5705, 0.606),
                         n1 = c(10L, 15L,
                                20L, 25L, 30L, 10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L, 25L, 30L,
                                10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L,
                                25L, 30L, 10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L, 25L, 30L, 10L,
                                15L, 20L, 25L, 30L, 10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L, 25L,
                                30L, 10L, 15L, 20L, 25L, 30L),
                         n2 = c(10L, 15L, 20L, 25L, 30L,
                                10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L,
                                25L, 30L, 10L, 15L, 20L, 25L, 30L, 10L, 15L, 20L, 25L, 30L, 30L,
                                30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L,
                                30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L, 30L,
                                30L, 30L, 30L),
                         delta0 = c(0, 0, 0, 0, 0, 0.1, 0.1, 0.1, 0.1,
                                    0.1, 0.2, 0.2, 0.2, 0.2, 0.2, 0.3, 0.3, 0.3, 0.3, 0.3, 0.4, 0.4,
                                    0.4, 0.4, 0.4, 0.5, 0.5, 0.5, 0.5, 0.5, 0, 0, 0, 0, 0, 0.1, 0.1,
                                    0.1, 0.1, 0.1, 0.2, 0.2, 0.2, 0.2, 0.2, 0.3, 0.3, 0.3, 0.3, 0.3,
                                    0.4, 0.4, 0.4, 0.4, 0.4, 0.5, 0.5, 0.5, 0.5, 0.5)),
                    .Names = c("power", "n1", "n2", "delta0"),
                    row.names = c(NA, 60L),
                    class = "data.frame")
  owen <- numeric(nrow(PASS))
  for(i in 1:nrow(PASS)){
    owen[i] <- powerTOST(alpha=0.05, delta0=PASS$delta0[i], Delta=1, sigma=1,
                         n1=PASS$n1[i], n2=PASS$n2[i])

  }
  expect_true(identical(round(owen,4), PASS$power))
})

test_that("powen4 - infinite nu", {
  t1 <- 2; t2 <- 1; delta1 <- 4; delta2 <- 2
  expect_equal(powen4(2000, t1, t2, delta1, delta2, algo),
               powen4(Inf, t1, t2, delta1, delta2),
               tolerance=1e-4)
})

test_that("powen4 - delta2=-Inf", {
  # the result does not depend on t2
  nu <- 2; t1 <- 3; delta1 <- 2 # rk: works only for nu=1 and nu=2
  x1 <- OwenQ:::RcppOwenCDF4(nu, t1, 1, delta1, -Inf, algo)
  x2 <- OwenQ:::RcppOwenCDF4(nu, t1, 2, delta1, -Inf, algo)
  expect_true(x1==x2)
  # so the result is 1-P1 (because T2=-Inf)
  expect_equal(x1, 1-ptOwen(t1, nu, delta1), tolerance=1e-15)
  # now this is implemented in powen4
  x <- powen4(nu, t1, 2, delta1, -Inf)
  expect_equal(x, x1, tolerance=1e-15)
})

test_that("powen4 - delta1=Inf", {
  # the result does not depend on t1
  nu <- 2; t2 <- 1; delta2 <- 2
  x1 <- powen4(nu, 3, t2, 100, delta2, algo)
  x2 <- powen4(nu, 13, t2, 100, delta2, algo)
  expect_true(x1==x2)
  # so the result is P2 (rather because T1=Inf)
  expect_equal(x1, ptOwen(t2, nu, delta2), tolerance=1e-16)
  # boost version: delta1 = Inf ne marche plus
  # BIZARRE
  expect_equal(OwenQ:::RcppOwenCDF4(1, 3, t2, 1000, delta2, algo),
               ptOwen(t2, 1, delta2),
               tolerance=1e-15)
  # now this is implemented in powen4
  x <- powen4(nu, 3, t2, Inf, delta2)
  expect_equal(x1, x, tolerance=1e-16)
})

test_that("powen4 - delta1=Inf and delta2=-Inf", {
  # the result is 1
  expect_true(powen4(2, 3, 1, 100, -100, algo) == 1)
  expect_true(powen4(Inf, 3, 1, 100, -100, algo) == 1)
  # => what if t1=Inf ? for instance t1=delta1 -> Inf
  # now this is implemented in powen4
  expect_true(powen4(2, 3, 1, Inf, -Inf) == 1)
})

test_that("powen4 - delta1=Inf and delta2=Inf", {
  # the result is 0
  expect_true(powen4(2, 3, 1, 101, 100, algo) == 0)
  expect_true(powen4(Inf, 3, 1, 101, 100) == 0)
  # now this is implemented in powen4
  expect_true(psbt4(2, 3, 1, Inf, Inf) == 0)
})

test_that("powen3", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- 1 - OwenQ1(nu, t2, delta2, R, algo) - OwenQ2(nu, t1, delta1, R, algo)
  owen3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  expect_equal(diff, owen3, tolerance=1e-15)
  wolfram <- 0.809137482066635
  expect_equal(owen3, wolfram, tolerance=1e-9)
  #
  nu <- 5
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- 1 - OwenQ1(nu, t2, delta2, R, algo) - OwenQ2(nu, t1, delta1, R, algo)
  owen3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  expect_equal(diff, owen3, tolerance=1e-15)
  wolfram <- 0.806507459306199
  expect_equal(owen3, wolfram, tolerance=1e-9)
})

test_that("powen3+powen4=1-P1", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  owen3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  owen4 <- powen4(nu, t1, t2, delta1, delta2, algo)
  P1 <- ptOwen(t1, nu, delta1)
  expect_equal(owen3+owen4, 1-P1, tolerance=1e-15)
  nu <- 5
  owen3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  owen4 <- powen4(nu, t1, t2, delta1, delta2, algo)
  P1 <- ptOwen(t1, nu, delta1)
  #expect_true(owen3+owen4 == 1-P1)
  expect_equal(owen3+owen4, 1-P1, tolerance=1e-15)
})

test_that("powen3 - infinite nu", {
  t1 <- 2; t2 <- 1; delta1 <- 4; delta2 <- 2
  expect_equal(powen3(2000, t1, t2, delta1, delta2, algo),
               powen3(Inf, t1, t2, delta1, delta2),
               tolerance=1e-8)
})

test_that("powen3 - delta2=-Inf", {
  # the result is 0
  nu <- 2; t1 <- 3; delta1 <- 2 # rk: works only for nu=1 and nu=2
  x1 <- OwenQ:::RcppOwenCDF3(nu, t1, 1, delta1, -Inf, algo)
  expect_true(x1==0)
  # now this is implemented in powen3
  x <- powen3(nu, t1, 2, delta1, -Inf)
  expect_true(x==0)
})

test_that("powen3 - delta1=Inf", {
  # the result does not depend on t1
  nu <- 2; t2 <- 1; delta2 <- 2
  x1 <- powen3(nu, 3, t2, 100, delta2, algo)
  x2 <- powen3(nu, 13, t2, 100, delta2, algo)
  expect_true(x1==x2)
  # so the result is 1-P1-P2 = 1-P2
  expect_equal(x1, 1-ptOwen(99, nu, Inf)-ptOwen(t2, nu, delta2), tolerance=1e-15)
  #expect_true(OwenQ:::RcppOwenCDF3(1, 3, t2, Inf, delta2) == 1-ptOwen(t2, 1, delta2))
  # boost version: delta1=Inf gives NaN
  expect_true(OwenQ:::RcppOwenCDF3(1, 3, t2, 1000, delta2, algo) == 1-ptOwen(t2, 1, delta2))
  # now this is implemented in powen3
  x <- powen3(nu, 3, t2, Inf, delta2)
  expect_equal(x1, x, tolerance=1e-15)
})

test_that("powen3 - delta1=Inf and delta2=-Inf", {
  # the result is 0
  expect_true(powen3(2, 3, 1, 100, -100, algo) == 0)
  expect_true(powen3(Inf, 3, 1, 100, -100, algo) == 0)
  # now this is implemented in powen3
  expect_true(powen3(2, 3, 1, Inf, -Inf) == 0)
})

test_that("powen3 - delta1=Inf and delta2=Inf", {
  # the result is 1
  expect_true(powen3(2, 3, 1, 101, 100, algo) == 1)
  expect_true(powen3(Inf, 3, 1, 101, 100, algo) == 1)
  # now this is implemented in powen3
  expect_true(psbt3(2, 3, 1, Inf, Inf) == 1)
})

test_that("powen3 - delta1=-Inf and delta2=-Inf", {
  # the result is 0
  expect_true(powen3(2, 3, 1, -100, -101, algo) == 0)
  expect_true(powen3(Inf, 3, 1, -100, -101, algo) == 0)
  # now this is implemented in powen3
  expect_true(psbt3(2, 3, 1, -Inf, -Inf) == 0)
})


test_that("powen2", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- OwenQ2(nu, t1, delta1, R, algo) - OwenQ2(nu, t2, delta2, R, algo)
  owen2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  expect_equal(diff, owen2, tolerance=1e-16)
  wolfram <- 0.03257737810540227
  expect_equal(owen2, wolfram, tolerance=1e-10)
  #
  nu <- 5
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- OwenQ2(nu, t1, delta1, R, algo) - OwenQ2(nu, t2, delta2, R, algo)
  owen2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  expect_equal(diff, owen2, tolerance=1e-16)
  wolfram <- 0.0353568969628651
  expect_equal(owen2, wolfram, tolerance=1e-9)
})


test_that("powen2+powen3=1-P2", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  owen2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  owen3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  P2 <- ptOwen(t2, nu, delta2)
  expect_equal(owen2+owen3, 1-P2, tolerance=1e-15)
  nu <- 5
  owen2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  owen3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  P2 <- ptOwen(t2, nu, delta2)
  expect_equal(owen2+owen3, 1-P2, tolerance=1e-15)
})

test_that("powen2 - infinite nu", {
  t1 <- 2; t2 <- 1; delta1 <- 4; delta2 <- 2
  expect_true(powen2(Inf, t1, t2, delta1, delta2) == 0)
  t1 <- 4; t2 <- 1; delta1 <- 4; delta2 <- 2
  expect_equal(powen2(2000, t1, t2, delta1, delta2, algo),
               powen2(Inf, t1, t2, delta1, delta2),
               tolerance=1e-3)
})

test_that("powen2 - delta2=-Inf", {
  # the result is 0
  nu <- 2; t1 <- 3; delta1 <- 2 # rk: works only for nu=1 and nu=2
  x1 <- OwenQ:::RcppOwenCDF2(nu, t1, 1, delta1, -Inf, algo)
  expect_true(x1==0)
  # now this is implemented in powen2
  x <- powen2(nu, t1, 2, delta1, -Inf)
  expect_true(x==0)
})

test_that("powen2 - delta1=Inf", {
  # the result is 0
  nu <- 2; t2 <- 1; delta2 <- 2
  x1 <- powen2(nu, 3, t2, 100, delta2, algo)
  x2 <- powen2(nu, 13, t2, 100, delta2, algo)
  expect_true(x1==0)
  expect_equal(x2, 0, tolerance=1e-30)
  # now this is implemented in powen2
  x <- powen2(nu, 3, t2, Inf, delta2)
  expect_true(x==0)
})

test_that("powen2 - delta1=Inf and delta2=-Inf", {
  # the result is 0
  expect_true(powen2(2, 3, 1, 100, -100, algo) == 0)
  expect_true(powen2(Inf, 3, 1, 100, -100) == 0)
  # now this is implemented in powen2
  expect_true(powen2(2, 3, 1, Inf, -Inf) == 0)
})

test_that("powen2 - delta1=Inf and delta2=Inf", {
  # the result is 0
  expect_true(powen2(2, 3, 1, 101, 100, algo) == 0)
  expect_true(powen2(Inf, 3, 1, 101, 100) == 0)
  # now this is implemented in powen2
  expect_true(psbt2(2, 3, 1, Inf, Inf) == 0)
})

test_that("powen2 - delta1=-Inf and delta2=-Inf", {
  # the result is 0
  expect_true(powen2(2, 3, 1, -100, -101, algo) == 0)
  expect_true(powen2(Inf, 3, 1, -100, -101) == 0)
  # now this is implemented in powen2
  expect_true(psbt2(2, 3, 1, -Inf, -Inf) == 0)
})


test_that("powen1", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- OwenQ1(nu, t1, delta1, R, algo) + OwenQ2(nu, t2, delta2, R, algo)
  owen1 <- powen1(nu, t1, t2, delta1, delta2)
  expect_equal(diff, owen1, tolerance=1e-16)
  wolfram <- 0.1404299569049368
  expect_equal(owen1, wolfram, tolerance=1e-8)
  #
  nu <- 5
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  diff <- OwenQ1(nu, t1, delta1, R, algo) + OwenQ2(nu, t2, delta2, R, algo)
  owen1 <- powen1(nu, t1, t2, delta1, delta2, algo)
  expect_equal(diff, owen1, tolerance=1e-16)
  wolfram <- 0.1394458271284726
  expect_equal(owen1, wolfram, tolerance=1e-8)
})


test_that("powen1+powen2=P1", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  owen1 <- powen1(nu, t1, t2, delta1, delta2, algo)
  owen2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  P1 <- ptOwen(t1, nu, delta1)
  expect_equal(owen1+owen2, P1, tolerance=1e-15)
  nu <- 5
  owen1 <- powen1(nu, t1, t2, delta1, delta2, algo)
  owen2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  P1 <- ptOwen(t1, nu, delta1)
  expect_equal(owen1+owen2, P1, tolerance=1e-15)
})

test_that("powen1 - infinite nu", {
  t1 <- 4; t2 <- 1; delta1 <- 4; delta2 <- 2
  expect_equal(powen1(2000, t1, t2, delta1, delta2, algo),
               powen1(Inf, t1, t2, delta1, delta2),
               tolerance=1e-8)
})

test_that("powen1 - delta2=-Inf", {
  # the result is P1
  nu <- 2; t1 <- 3; delta1 <- 2 # rk: works only for nu=1 and nu=2
  x1 <- OwenQ:::RcppOwenCDF1(nu, t1, 1, delta1, -Inf, algo)
  x2 <- ptOwen(t1, nu, delta1)
  expect_equal(x1, x2, tolerance=1e-15)
  # now this is implemented in powen1
  x <- powen1(nu, t1, 2, delta1, -Inf)
  expect_true(x==x2)
})

test_that("powen1 - delta1=Inf", {
  # the result is 0
  nu <- 2; t2 <- 1; delta2 <- 2
  x1 <- powen1(nu, 3, t2, 100, delta2, algo)
  x2 <- powen1(nu, 13, t2, 100, delta2, algo)
  expect_true(x1==0)
  expect_equal(x2, 0, tolerance=1e-25)
  # now this is implemented in powen1
  x <- powen1(nu, 3, t2, Inf, delta2)
  expect_true(x==0)
})

test_that("powen1 - delta1=Inf and delta2=-Inf", {
  # the result is 0
  expect_true(powen1(2, 3, 1, 100, -100, algo) == 0)
  expect_true(powen1(Inf, 3, 1, 100, -100) == 0)
  # now this is implemented in powen1
  expect_true(powen1(2, 3, 1, Inf, -Inf) == 0)
})

test_that("powen1 - delta1=Inf and delta2=Inf", {
  # the result is 0
  expect_true(powen1(2, 3, 1, 101, 100, algo) == 0)
  expect_true(powen1(Inf, 3, 1, 101, 100) == 0)
  # now this is implemented in powen1
  expect_true(psbt1(2, 3, 1, Inf, Inf) == 0)
})

test_that("powen1 - delta1=-Inf and delta2=-Inf", {
  # the result is 1
  expect_true(powen1(2, 3, 1, -100, -101, algo) == 1)
  expect_true(powen1(Inf, 3, 1, -100, -101) == 1)
  # now this is implemented in powen1
  expect_true(psbt1(2, 3, 1, -Inf, -Inf) == 1)
})

test_that("The powen's sum to 1", {
  nu=5; t1=2; t2=1; delta1=3; delta2=2
  p1 <- powen1(nu, t1, t2, delta1, delta2, algo)
  p2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  p3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  p4 <- powen4(nu, t1, t2, delta1, delta2, algo)
  expect_true(p1+p2+p3+p4 == 1)
  # case t2>t1
  t2=3
  p1 <- powen1(nu, t1, t2, delta1, delta2, algo)
  p2 <- powen2(nu, t1, t2, delta1, delta2, algo)
  p3 <- powen3(nu, t1, t2, delta1, delta2, algo)
  p4 <- powen4(nu, t1, t2, delta1, delta2, algo)
  expect_true(p1+p2+p3+p4 == 1)
})

context("OwenQ2 algo1")

algo <- 1

test_that("OwenQ2 for R=0 equals ptOwen", {
  skip_on_os("mac")
  owenQ2 <- sapply(1:8, function(nu) OwenQ2(nu=nu, t=2, delta=2, R=0, algo))
  owenS <- sapply(1:8, function(nu) ptOwen(q=2, nu=nu, delta=2))
  expect_equal(owenQ2, owenS, tolerance=1e-15)
})

test_that("OwenQ2 is correctly vectorized", {
  delta <- c(Inf, 0, -Inf); R <- c(1,2,3)
  nu <- 5; t <- 2
  expect_identical(OwenQ2(nu, t, delta, R, algo),
                   c(OwenQ2(nu, t, delta[1], R[1], algo),
                     OwenQ2(nu, t, delta[2], R[2], algo),
                     OwenQ2(nu, t, delta[3], R[3], algo)))
})

test_that("OwenQ1+OwenQ2 equals ptOwen", {
  owenQ2 <- sapply(1:8,
                   function(nu){
                     OwenQ1(nu=nu, t=2, delta=2, R=1, algo) +
                       OwenQ2(nu=nu, t=2, delta=2, R=1, algo)
                     })
  owenS <- sapply(1:8, function(nu) ptOwen(q=2, nu=nu, delta=2))
  expect_equal(owenQ2, owenS, tolerance=1e-15)
})

test_that("OwenQ2 for t=+Inf does not depend on delta", {
  expect_true(OwenQ2(5, Inf, 2, 2) == OwenQ2(5, Inf, 3, 2))
  expect_true(OwenQ2(6, Inf, 2, 2) == OwenQ2(6, Inf, 3, 2))
  # does not depend on t for delta=-Inf and the same result
  expect_equal(OwenQ2(5, Inf, 2, 2), OwenQ2(5, 1, -100, 2, algo), tolerance=1e-15)
  expect_equal(OwenQ2(6, Inf, 2, 2), OwenQ2(6, 1, -100, 2, algo), tolerance=1e-15)
  # now delta=-Inf is implemented
  expect_equal(OwenQ2(5, Inf, 2, 2), OwenQ2(5, 1, -Inf, 2), tolerance=1e-15)
  expect_equal(OwenQ2(6, Inf, 2, 2), OwenQ2(6, 1, -Inf, 2), tolerance=1e-15)
})

test_that("OwenQ2 for delta=Inf", {
  expect_true(OwenQ2(5, 1, Inf, 2) == 0)
  expect_equal(OwenQ2(5, 1, 100, 2, algo), 0, tolerance=1e-15)
})

test_that("OwenQ2 for t=-Inf equals 0", {
  expect_equal(OwenQ2(5, -Inf, 2, 1), 0, tolerance=1e-16)
  expect_true(OwenQ2(6, -Inf, 2, 1) == 0)
})

test_that("OwenQ2 for |t|=Inf and R=0", {
  expect_true(OwenQ2(1, Inf, 2, 0) == 1)
  expect_true(OwenQ2(1, -Inf, 2, 0) == 0)
})


test_that("OwenQ2 - bivariate Student", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  owen <- - OwenQ2(nu, t2, delta2, R, algo) + OwenQ2(nu, t1, delta1, R, algo)
  wolfram <- 0.03257737810540227
  expect_equal(owen, wolfram, tolerance=1e-10)
  #
  nu <- 5
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  owen <- - OwenQ2(nu, t2, delta2, R, algo) + OwenQ2(nu, t1, delta1, R, algo)
  wolfram <- 0.0353568969628651
  expect_equal(owen, wolfram, tolerance=1e-9)
})

test_that("OwenQ2 - numerical integration", {
  wolfram <- c(5.7330314375838782335e-7, 3.7266531720786709899e-6, 0.000015440498291040247642, 0.000050309817486816081076, 0.00013933372105156197162, 0.00034145176657217697536, 0.00075875604691111263929, 0.0015541802819728694091, 0.0029690444288361936486, 0.0053365202327988767708)
  owen <- sapply(1:10, function(nu) OwenQ2(nu, 3, 2, 5, algo))
  expect_equal(owen, wolfram, tolerance=1e-14)
})

context("ptOwen")

test_that("ptOwen = pt", {
  ncp <- 1
  expect_equal(ptOwen(2, nu=3, delta=ncp), pt(2, df=3, ncp=ncp), tolerance=1e-13)
  expect_equal(ptOwen(2, nu=4, delta=ncp), pt(2, df=4, ncp=ncp), tolerance=1e-12)
  expect_equal(ptOwen(2, nu=5, delta=ncp), pt(2, df=5, ncp=ncp), tolerance=1e-12)
  ncp <- 10
  expect_equal(ptOwen(2, nu=3, delta=ncp), pt(2, df=3, ncp=ncp), tolerance=1e-12)
  expect_equal(ptOwen(2, nu=4, delta=ncp), pt(2, df=4, ncp=ncp), tolerance=1e-13)
  expect_equal(ptOwen(2, nu=5, delta=ncp), pt(2, df=5, ncp=ncp), tolerance=1e-12)
  q <- -1; ncp <- 1
  expect_equal(ptOwen(q, nu=3, delta=ncp), pt(q, df=3, ncp=ncp), tolerance=1e-14)
  ncp <- -1
  expect_equal(ptOwen(q, nu=3, delta=ncp), pt(q, df=3, ncp=ncp), tolerance=1e-13)
})

test_that("ptOwen for infinite delta", {
  expect_true(ptOwen(2, nu=3, delta=100) == 0)
  expect_true(ptOwen(2, nu=3, delta=-100) == 1)
})

test_that("ptOwen = Q2 for R=0", {
  skip_on_os("mac")
  expect_equal(ptOwen(2, 5, 1.5), OwenQ2(5, 2, 1.5, 0), tolerance=1e-14)
})

context("OwenQ1 algo2")

algo <- 2

test_that("OwenQ1 for large R equals ptOwen", {
  expect_equal(OwenQ1(4, 3, 2, 100, algo), ptOwen(3, 4, 2), tolerance=1e-15)
  expect_equal(OwenQ1(5, 3, 2, 100, algo), ptOwen(3, 5, 2), tolerance=1e-10)
  expect_equal(OwenQ1(5, 3, 2, 100, algo), pt(3, 5, 2), tolerance=1e-10)
})

test_that("OwenQ1 is correctly vectorized", {
  delta <- c(Inf, 0, -Inf); R <- c(1,2,3)
  nu <- 5; t <- 2
  expect_identical(OwenQ1(nu, t, delta, R),
                   c(OwenQ1(nu, t, delta[1], R[1]), OwenQ1(nu, t, delta[2], R[2]),
                     OwenQ1(nu, t, delta[3], R[3])))
})

test_that("OwenQ1 for t=+Inf does not depend on delta", {
  expect_true(OwenQ1(5, Inf, 2, 2) == OwenQ1(5, Inf, 3, 2))
  expect_equal(OwenQ1(6, Inf, 2, 2), OwenQ1(6, Inf, 3, 2), tolerance=1e-16)
  # nu=2 => moment truncated normal
  expect_equal(OwenQ1(2, Inf, 1, 2), sqrt(2*pi)*(dnorm(0)-dnorm(2)), tolerance=1e-15)
  # nu >=1 => incomplete Gamma
  R <- 2; nu <- 6
  expect_equal(OwenQ1(nu, Inf, 3, R), pgamma(R^2/2, nu/2),
               tolerance=1e-14)
  # does not depend on t for delta=-Inf and the same result
  expect_equal(OwenQ1(5, Inf, 2, 2), OwenQ1(5, 1, -100, 2, algo), tolerance=1e-15)
  expect_equal(OwenQ1(6, Inf, 2, 2), OwenQ1(6, 1, -100, 2, algo), tolerance=1e-15)
  expect_equal(OwenQ1(1, Inf, 2, 2), OwenQ:::RcppOwenQ1(1, 1, -Inf, 2, algo), tolerance=1e-15)
  expect_equal(OwenQ1(2, Inf, 2, 2), OwenQ:::RcppOwenQ1(2, 1, -Inf, 2, algo), tolerance=1e-15)
  # now delta=-Inf is implemented
  expect_equal(OwenQ1(5, Inf, 2, 2), OwenQ1(5, 1, -Inf, 2), tolerance=1e-15)
  expect_equal(OwenQ1(6, Inf, 2, 2), OwenQ1(6, 1, -Inf, 2), tolerance=1e-15)
})

test_that("OwenQ1 for t=-Inf equals 0", {
  expect_true(OwenQ1(5, -Inf, 2, 100) == 0)
  expect_equal(OwenQ1(6, -Inf, 2, 100), 0, tolerance=1e-17)
})

test_that("OwenQ1 - comparison Wolfram", {
  owen <- OwenQ1(1, 3, 2, 1, algo)
  wolfram <- 0.219018703856082
  expect_equal(owen, wolfram, tolerance=1e-15)
  wolfram <- c(0.52485658843054409291,0.62938193306526904118,0.68001173355723140333,0.71048916647247223585,
               0.73097050978732740047,0.74563903448183001384,0.75650064658430460294,0.76456656856157965989,
               0.77030437685878389173,0.77383547873740988537)
  owen <- sapply(1:10, function(nu) OwenQ1(nu, 3, 2, 5, algo))
  expect_equal(owen, wolfram, tolerance=1e-15)
})

test_that("OwenQ1 - bivariate Student", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  owen <- OwenQ1(nu, t2, delta2, R, algo) - OwenQ1(nu, t1, delta1, R, algo)
  pmvt <- mvtnorm::pmvt(lower=c(t1,-Inf), upper=c(Inf,t2), delta=c(delta1, delta2),
                df=nu, corr=cbind(c(1,1),c(1,1)))
  expect_equal(owen, pmvt[1], tolerance=1e-4, check.attributes=FALSE)
  wolfram <- 0.01785518085912236
  expect_equal(owen, wolfram, tolerance=1e-11)
  #
  nu <- 5
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  owen <- OwenQ1(nu, t2, delta2, R, algo) - OwenQ1(nu, t1, delta1, R, algo)
  wolfram <- 0.01868982415809893
  expect_equal(owen, wolfram, tolerance=1e-9)
  # wolfram input:
  # With[{t1 = 2, t2=1,delta1=3, delta2=2, nu=6},
  #      NProbability[
  #        (x+delta1)/Sqrt[y/nu] >= t1 && (x+delta2)/Sqrt[y/nu] <=t2, {x \[Distributed]
  #          NormalDistribution[], y\[Distributed]ChiSquareDistribution[nu]}]]
})

test_that("OwenQ1 - bivariate Student", {
  t1 <- 2; t2 <- 1; delta1 <- 3; delta2 <- 2
  nu <- 6
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  owen <- - (ptOwen(t2, nu, delta2) - OwenQ1(nu, t2, delta2, R, algo)) +
             (ptOwen(t1, nu, delta1) - OwenQ1(nu, t1, delta1, R, algo))
  wolfram <- 0.03257737810540227
  expect_equal(owen, wolfram, tolerance=1e-10)
  #
  nu <- 5
  R <- sqrt(nu)*(delta1 - delta2)/(t1-t2)
  owen <- - (ptOwen(t2, nu, delta2) - OwenQ1(nu, t2, delta2, R, algo)) +
    (ptOwen(t1, nu, delta1) - OwenQ1(nu, t1, delta1, R, algo))
  wolfram <- 0.0353568969628651
  expect_equal(owen, wolfram, tolerance=1e-9)
})

---
title: "Owen cumulative functions"
author: "Stéphane Laurent"
date: "`r Sys.Date()`"
output: 
  rmarkdown::html_vignette:
    fig_caption: no
    number_sections: no
    toc: yes
vignette: >
  %\VignetteIndexEntry{Owen cumulative functions}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
library(OwenQ)
knitr::opts_chunk$set(collapse=TRUE)
```


# The Owen distribution

Let $Z \sim {\cal N}(0,1)$ and $X \sim \chi^2_\nu$ be two independent random variables.
For real numbers $\delta_1$ and $\delta_2$, define the two random variables
$$
T_1 = \frac{Z+\delta_1}{\sqrt{X/\nu}}
\quad \text{and} \quad\;
T_2 = \frac{Z+\delta_2}{\sqrt{X/\nu}}.
$$

Both $T_1$ and $T_2$ follow a non-central Student distribution. 
The number of degrees of freedom is $\nu$ for each of them, and their respective non-centrality parameters are $\delta_1$ and $\delta_2$ respectively. 

Owen (1965) studied the distribution of the pair $(T_1, T_2)$.

The four Owen cumulative functions are
$$
\begin{align}
O_1(\nu, t_1, t_2, \delta_1, \delta_2) & = \Pr(T_1 \leq t_1, T_2 \leq t_2), \\
O_2(\nu, t_1, t_2, \delta_1, \delta_2) & = \Pr(T_1 \leq t_1, T_2 \geq t_2), \\
O_3(\nu, t_1, t_2, \delta_1, \delta_2) & = \Pr(T_1 \geq t_1, T_2 \geq t_2), \\
O_4(\nu, t_1, t_2, \delta_1, \delta_2) & = \Pr(T_1 \geq t_1, T_2 \leq t_2).
\end{align}
$$

Owen provided an efficient way to evaluate these functions *when $\nu$ is an integer number*. Owen's algorithms are implemented in the `OwenQ` package. 

For $\delta_1 > \delta_2$, these four functions are implemented in the `OwenQ` package under the respective names `powen1`, `powen2`, `powen3` and `powen4`. 
For general values of $\delta_1$ and $\delta_2$, they are implemented under the respective names `psbt1`, `psbt2`, `psbt3` and `psbt4`. 


# Non-central Student distribution 

Owen (1965) also provided an algorithm to evaluate the cumulative distribution function of a univariate non-central Student distribution with an integer number of degrees of freedom. 
This evaluation is performed by the function `ptOwen` of the `OwenQ` package.

```{r}
ptOwen(q=1, nu=3, delta=2)
pt(q=1, df=3, ncp=2)
```

It is known that the `pt` function is not reliable when the non-centrality parameter `ncp` is large. 
Below we compare the values given by `ptOwen` and `pt` to the value given by Wolfram|Alpha (returned by the command `N[CDF[NoncentralStudentTDistribution[4,70],80]]`):

```{r}
p1 <- pt(q=80, df=4, ncp=70)
p2 <- ptOwen(q=80, nu=4, delta=70)
wolfram <- 0.54742763380700947685
p1 - wolfram
p2 - wolfram
```


# Limitations

When `q`$=$`delta`, the value of `ptOwen(q, nu, delta)` should go to `0.5` as `nu` increases to infinity. The examples below show the failure of this expectation when `nu` is too large.

```{r ptOwen_fails}
ptOwen(q=50, nu=3500, delta=50)
ptOwen(q=50, nu=3600, delta=50)
ptOwen(q=50, nu=3650, delta=50)
ptOwen(q=50, nu=3660, delta=50)
ptOwen(q=50, nu=3670, delta=50)
ptOwen(q=50, nu=3680, delta=50)
```

Since all Owen's algorithms are somehow similar to the algorithm evaluating `ptOwen`, we can suspect that the other ones also suffer from certain limitations. 
In the other vignette, we investigate the reliability and the limitations of `OwenQ`. 

In order to do some comparisons, and thanks to the `BH` package, we have ported the `boost` implementation of the cumulative Student distribution to `OwenQ`. It is evaluated by the internal function `pt_boost`. We concluded that this function is highly reliable. In particular it does not suffer from the failures of `ptOwen` we have just shown:

```{r pt_boost}
OwenQ:::pt_boost(q=50, nu=3500, delta=50)
OwenQ:::pt_boost(q=50, nu=3600, delta=50)
OwenQ:::pt_boost(q=50, nu=3650, delta=50)
OwenQ:::pt_boost(q=50, nu=3660, delta=50)
OwenQ:::pt_boost(q=50, nu=3670, delta=50)
OwenQ:::pt_boost(q=50, nu=3680, delta=50)
```


# Application to equivalence testing 

The Owen distribution intervenes in the calculation of the power of equivalence tests. 

## One sample 

Assume a statistical model given by a sample 
$y_i \sim_{\text{iid}} {\cal N}(\mu, \sigma^2)$ for $i=1, \ldots, n$. 
We want to demonstrate that, up to a given confidence level, the mean $\mu$ belongs to a certain interval $[\Delta_1, \Delta_2]$. 
In other words, we are interested in the alternative hypothesis 
$H_1\colon\{\Delta_1 \leq \mu \leq \Delta_2\}$. 

Consider the usual $100(1-2\alpha)\%$-confidence interval about $\mu$:
$$
\left[\bar y - t^\ast_{n-1}(\alpha)\frac{\hat\sigma}{\sqrt{n}}, \, 
\bar y + t^\ast_{n-1}(\alpha)\frac{\hat\sigma}{\sqrt{n}} \right].
$$

The $H_1$ hypothesis is accepted at level $\alpha$ when this interval falls into the interval $[\Delta_1, \Delta_2]$.

This can be written as follows:
$$
T_1 := 
\frac{\bar y - \Delta_1}{\hat\sigma/\sqrt{n}} 
\geq t^\ast_{n-1}(\alpha)
\quad \text{and} \quad 
T_2 := 
\frac{\bar y - \Delta_2}{\hat\sigma/\sqrt{n}} 
\leq - t^\ast_{n-1}(\alpha).
$$

Observe that 
$$
T_1 = \frac{z - \delta_1}{\dfrac{\sqrt{n-1}\hat\sigma/\sigma}{\sqrt{n-1}}}
$$
where
$$
z = \frac{\sqrt{n}}{\sigma}(\bar y - \mu) \sim {\cal N}(0,1)
\quad \text{and} \quad 
\delta_1 = \frac{\mu - \Delta_1}{\sigma/\sqrt{n}}.
$$

By reasoning in the same way for $T_2$, we find that the pair $(T_1, T_2)$ follows the 
Owen distribution with degrees of freedom $\nu = n-1$, and non-centrality 
parameters $\delta_1$ given above and 
$\delta_2 = \tfrac{\mu - \Delta_2}{\sigma/\sqrt{n}}$.

Therefore the power of the test - *i.e.* the probability to accept $H_1$ - is given by 
$$
O_4\bigl(n-1, t^\ast_{n-1}(\alpha), -t^\ast_{n-1}(\alpha), \delta_1, \delta_2\bigr),
$$
and then can be evaluated thanks to `powen4`. 

## Inconclusive equivalence test

The result of the equivalence test is said to be *inconclusive* when only one of the bounds of the confidence interval falls into the interval $[\Delta_1, \Delta_2]$. 

The probability to get an inconclusive result can be obtained with the `OwenQ` package. We show and check that below with the help of simulations.

```{r}
Delta1 <- -2; Delta2 <- 2 
mu <- 1; sigma <- 6; n <- 30L
alpha <- 0.05
nsims <- 1e6L
equivalence <- inconclusive <- numeric(nsims)
for (i in 1L:nsims) {
  y <- rnorm(n, mu, sigma)
  CI <- t.test(x = y, conf.level = 1-2*alpha)$conf.int
  equivalence[i] <- (CI[1] > Delta1) && (CI[2] < Delta2)
  inconclusive[i] <- ((CI[1] < Delta1) && (CI[2] > Delta1)) ||
    ((CI[1] < Delta2) && (CI[2] > Delta2))
}
```

```{r}
dof <- n-1
q <- qt(1-alpha, dof)
se <- sqrt(1/n)*sigma
delta1 <- (mu-Delta1)/se; delta2 <- (mu-Delta2)/se
# probability to get equivalence
mean(equivalence)
powen4(dof, q, -q, delta1, delta2)
# probability to get inconclusive
mean(inconclusive)
ptOwen(q, dof, delta2) - ptOwen(-q, dof, delta1) - powen4(dof, q, -q, delta1, delta2)
```

## Parallel design 

Now consider two independent samples 
$x_i \sim_{\text{iid}} {\cal N}(\mu, \sigma^2)$ for $i=1, \ldots, n_1$. 
and 
$y_i \sim_{\text{iid}} {\cal N}(\nu, \sigma^2)$ for $i=1, \ldots, n_2$ 
and the alternative hypothesis 
$H_1\colon\bigl\{|\mu-\nu| \leq \Delta\bigr\}$. 
The power of this test is evaluated by the function `powerTOST` below. 
The parameter `delta0` corresponds to the difference $\mu-\nu$. 

```{r}
powerTOST <- function(alpha, delta0, Delta, sigma, n1, n2) {
  se <- sqrt(1/n1 + 1/n2) * sigma
  delta1 <- (delta0 + Delta) / se
  delta2 <- (delta0 - Delta) / se
  dof <- n1 + n2 - 2
  q <- qt(1 - alpha, dof)
  powen4(dof, q, -q, delta1, delta2)
}
```



# The Owen $T$-function

The `OwenQ` package also provides an implementation of the Owen $T$-function, 
under the name `OwenT`. 
This is a port of the function `owens_t` of `boost`, the peer-reviewed collection of C++ libraries.

```{r, echo=FALSE, fig.width=5, fig.height=5}
h <- seq(-3, 3, length.out=30)
a <- seq(-5, 5, length.out=30)
z <- outer(h, a, Vectorize(OwenT))
oldpar <- par(mar=c(0,2,0,0))
persp(h, a, z, theta=30, phi=30, expand=0.5, zlab="Owen T", ticktype = "detailed", col = "lightblue")
par(oldpar)
```


# The Owen $Q$-functions

The Owen cumulative functions are based on the two Owen $Q$-functions
$$
Q_1(\nu, t, \delta, R) = \frac{1}{\Gamma\left(\frac{\nu}{2}\right)2^{\frac12(\nu-2)}}
\int_0^R \Phi\left(\frac{tx}{\sqrt{\nu}}-\delta\right)
x^{\nu-1} e^{-\frac{x^2}{2}} \mathrm{d}x
$$
and
$$
Q_2(\nu, t, \delta, R) = \frac{1}{\Gamma\left(\frac{\nu}{2}\right)2^{\frac12(\nu-2)}}
\int_R^\infty \Phi\left(\frac{tx}{\sqrt{\nu}}-\delta\right)
x^{\nu-1} e^{-\frac{x^2}{2}} \mathrm{d}x.
$$

They are implemented in the `OwenQ` package under the respective names `OwenQ1` and `OwenQ2` (for integer values of $\nu$). 


# Application: Equal-tailed tolerance interval

Consider the statistical model given by a sample 
$y_i \sim_{\text{iid}} {\cal N}(\mu, \sigma^2)$ for $i=1, \ldots, n$. 

An equal-tailed $(p,\alpha)$-tolerance interval is an interval containing at least $100p\%$ of the "center data" with $100(1-\alpha)\%$ confidence. 

The natural choice for such an interval is, as shown by Owen (1965),
$$
\bigl[\bar y - k_e \hat\sigma, \bar y + k_e \hat\sigma]
$$
where $k_e$ satisfies 
$$
O_2(n-1, k_e\sqrt{n}, -k_e\sqrt{n}, \delta, -\delta) = 1-\alpha
$$
where $\delta = \sqrt{n}z_{(1+p)/2}$. 

Therefore, the tolerance factor $k_e$ can be determined with the help of the `powen2` function of the `OwenQ` package. 
But it is more efficient to use the function `spowen2` for this purpose; 
`spowen2(nu, t, delta)` has the same value as `powen2(nu, t, -t, delta, -delta)` but it is evaluated more efficiently.  

```{r}
p <- 0.9; alpha <- 0.05
n <- 100
delta <- sqrt(n)*qnorm((1+p)/2)
uniroot(function(ke) spowen2(n-1, ke*sqrt(n), delta) - (1-alpha), 
        lower=qnorm(1-alpha), upper=5, extendInt = "upX", tol=1e-9)$root
```

The $k_e$ factors are tabulated in Krishnamoorthy & Mathew's book.


# Internal functions: numerical integration

The `OwenQ` package provides three internal functions, `iOwenQ1`, `iOwenQ2` and `ipowen4`, which respectively perform the evaluation of $Q_1$, $Q_2$ and $O_4$ by numerical integration using the `RcppNumerical` package. 
They can be called with a positive non-integer value of $\nu$. 
The evaluation of $O_4$ with `ipowen4` is correct only for $t_1 > t_2$ and $\delta_1 > \delta_2$. 


# References

- Owen, D. B. (1965). *A special case of a bivariate noncentral t-distribution.* Biometrika 52, 437-446.

- Krishnamoorthy & Mathew (2009). *Statistical Tolerance Regions*. Wiley. 
